import { Grid, Typography, Button, Card, CardContent } from "@mui/material";
import { Link } from "react-router-dom";
import { useEffect } from "react";
import { useDispatch, useSelector } from "react-redux";
import Loader from "../../components/UI/Loader/Loader";
import HasAccess from "../../components/UI/HasAccess/HasAccess";
import { fetchProject, fetchProjects } from "../../store/actions/projectsActions";
import ProjectsList from "../../components/ProjectComponents/ProjectsList/ProjectsList";
import NewProject from "../NewProject/NewProject";
import ArrowForwardIcon from "@mui/icons-material/ArrowForward";

const Projects = () => {
    const dispatch = useDispatch();
    const { projects, project, loading } = useSelector(state => state.projects.projects);
    const { users, user} = useSelector(state => state.users);
    const members = useSelector(state => state.projects.projects)

    console.log(projects)
    console.log(project)
    console.log(users)

    useEffect(() => {
        dispatch(fetchProjects())
    }, [dispatch]);

    // useEffect(() => {
    //     dispatch(fetchProject())
    // }, [dispatch]);
    // console.log("project ", project);
    
    return <>
        {projects?.length > 0 || project?.length > 0 ?  (<>
            <Grid container columns={16} spacing={2}>
                <Grid
                    container
                    item
                    direction="row"
                    justifyContent="space-between"
                    alignItems="center"
                >
                    <Grid item xs={4}>
                        <Typography variant="h4">
                            Проекты
                        </Typography>
                            <HasAccess roles={["superuser", "admin", "user"]} >
                                <NewProject />
                            </HasAccess>
                        <Typography>
                            <Loader loading={loading} />
                            <ProjectsList projects={projects} members={members} />
                        </Typography>
                    </Grid>
                    <Grid item xs={7}  >
                    <Card>
                <h2>Проект - {project?.project?.title} </h2>
                <CardContent>
                    <strong>
                        <br></br>
                        Дата создания проекта: {project?.project?.createdAt}
                    </strong>
                    <strong>
                        <br></br>
                        Цвет: {project?.project?.color}
                    </strong>
                    <strong>
                        <br></br>
                        Автор проекта: {project?.project?.members[0]?.user.displayName}
                    </strong>
                    <strong>
                        <br></br>
                        Роль в проекте: {project?.project?.members[0]?.roleProject}
                    </strong>
                    <strong>
                        <br></br>
                        {/* <div style={{ display: 'flex', direction: 'column' }}>
                            Участники проекта:  {(project?.project?.members[0]?.user.displayName === user.displayName) ? <NewMember members={project?.project?.members} /> : null}
                        </div>

                        <ProjectMembersList users={users} project={project} members={project?.project?.members} roleProjectOfAuthor={project?.project?.members[0]?.roleProject} authorOfProject={project?.project?.members[0]?.user.displayName} /> */}
                    </strong>
                    <strong>
                        <br></br>
                        Задачи:
                        <br></br>
                    </strong>
                    {/* <strong>
                        <br></br>
                        <ProjectTasksBody
                            tasks={tasks}
                        />
                    </strong> */}
                </CardContent>
            </Card>
                    </Grid>
                </Grid>

            </Grid>
        </>) :
            <h1>Созданных проектов нет</h1>
        }
    </>
};

export default Projects;